///#include "main.h"
#include "renderer.h"
#include "sound.h"
#include "screen.h"
#include <time.h>

int pad_state;
int cur_time;
int now_sensor_x,now_sensor_y;
int bMenu=0;

#define GBWIDTH  160
#define GBHEIGHT 144

void pgBitBltN2(unsigned long x, unsigned long y, u16 *d)
{
	u32 *v0, *v1;
	u16 color;
	int r, g, b, cy, cb, cr;
	unsigned long yy;
	unsigned long xx;
	
	d += GUARD_LINE;
	for (yy=0; yy<GBHEIGHT; yy++) {
		v0 = &xfb[pg_drawframe][(yy*2+y)*320+x];
		v1 = v0+320;
		for (xx=0; xx<GBWIDTH; xx++){
			color = *d++;
			r = ((color      ) & 0x1F) << 3;
			g = ((color >>  5) & 0x1F) << 3;
			b = ((color >> 10) & 0x1F) << 3;
			
			cy = (299*r + 587*g + 114*b) / 1000;
			cb = (-16874*r - 33126*g + 50000*b + 12800000) / 100000;
			cr = (50000*r - 41869*g - 8131*b + 12800000) / 100000;
			
			*v0++ = *v1++ = (cy<<24) | (cb<<16) | (cy<<8) | cr;
		}
		d+=GUARD_LINE*2;
	}
}

void render_screen(void *buf)
{
	pgBitBltN2(80,96,(u16*)buf);
}

//SoNɕāAݏo͒ȂoNɏĂ - LCK
void renderer_update_sound()
{
	int sound_buf_len = 3584;
	static unsigned int nextbank=1;
	unsigned int playbank=cur_play/sound_buf_len;
	if (nextbank!=playbank) {
		snd_render(&sound_buf[nextbank*sound_buf_len/2],sound_buf_len/4);
		nextbank=((nextbank+1)&3);
	}
}

#define UPPER_THRESHOLD  0xcf
#define LOWER_THRESHOLD  0x2f
void renderer_update_pad()
{
	PADStatus pad[4];
	
	PAD_Read(pad);
	pad_state=0;
	if(pad[0].button & PAD_BUTTON_A)
		pad_state|=1;
	if(pad[0].button & PAD_BUTTON_B)
		pad_state|=2;
	if(pad[0].button & PAD_TRIGGER_Z)
		pad_state|=4;
	if(pad[0].button & PAD_BUTTON_START)
		pad_state|=8;
	
	if(pad[0].button & PAD_BUTTON_DOWN || pad[0].stickY < -65)
		pad_state|=16;
	if(pad[0].button & PAD_BUTTON_UP || pad[0].stickY > 65)
		pad_state|=32;
	if(pad[0].button & PAD_BUTTON_LEFT || pad[0].stickX < -65)
		pad_state|=64;
	if(pad[0].button & PAD_BUTTON_RIGHT || pad[0].stickX > 65)
		pad_state|=128;
	
	if(pad[0].button & PAD_TRIGGER_L)
		bMenu = 1;
}

void renderer_refresh()
{
	renderer_update_pad();
	renderer_update_sound();
}

void renderer_init()
{
	cur_time=0;
	
	renderer_reset();
}

void renderer_reset()
{
	pad_state=0;
	now_sensor_x=now_sensor_y=2047;
}

byte renderer_get_time(int type)
{
	unsigned long now=time(NULL)-cur_time;

	switch(type){
	case 8: // b
		return (byte)(now%60);
	case 9: // 
		return (byte)((now/60)%60);
	case 10: // 
		return (byte)((now/(60*60))%24);
	case 11: // (L)
		return (byte)((now/(24*60*60))&0xff);
	case 12: // (H)
		return (byte)((now/(256*24*60*60))&1);
	}
	return 0;
}

void renderer_set_time(int type,byte dat)
{
	unsigned long now=time(NULL);
	unsigned long adj=now-cur_time;

	switch(type){
	case 8: // b
		adj=(adj/60)*60+(dat%60);
		break;
	case 9: // 
		adj=(adj/(60*60))*60*60+(dat%60)*60+(adj%60);
		break;
	case 10: // 
		adj=(adj/(24*60*60))*24*60*60+(dat%24)*60*60+(adj%(60*60));
		break;
	case 11: // (L)
		adj=(adj/(256*24*60*60))*256*24*60*60+(dat*24*60*60)+(adj%(24*60*60));
		break;
	case 12: // (H)
		adj=(dat&1)*256*24*60*60+(adj%(256*24*60*60));
		break;
	}
	cur_time=now-adj;
}

void renderer_set_bibrate(bool bibrate)
{
}

word renderer_get_sensor(bool x_y)
{
	return (x_y?(now_sensor_x&0x0fff):(now_sensor_y&0x0fff));
}

int renderer_get_timer_state()
{
	return cur_time;
}

void renderer_set_timer_state(int timer)
{
	cur_time=timer;
}
